/**
 * @license ngx-strength-meter
 * MIT license
 */

import { Component, EventEmitter, Input, Output, NgModule } from '@angular/core';
import zxcvbn from 'zxcvbn/dist/zxcvbn.js';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var StrengthMeterComponent = /** @class */ (function () {
    function StrengthMeterComponent() {
        this.measure = new EventEmitter();
    }
    Object.defineProperty(StrengthMeterComponent.prototype, "value", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value) {
                var /** @type {?} */ result = zxcvbn(value);
                this.strength = result.score;
                this.measure.emit(this.strength);
            }
            else {
                this.strength = undefined;
            }
        },
        enumerable: true,
        configurable: true
    });
    StrengthMeterComponent.decorators = [
        { type: Component, args: [{
                    template: "\n        <div class=\"strength-meter\">\n            <div class=\"strength-meter-fill\" [attr.data-strength]=\"strength\"></div>\n        </div>\n    ",
                    selector: 'strength-meter',
                    styles: ["\n            .strength-meter {\n                position: relative;\n                height: 3px;\n                background: #DDD;\n                margin: 10px auto 20px;\n                border-radius: 3px;\n            }\n\n            .strength-meter:before,\n            .strength-meter:after {\n                content: '';\n                height: inherit;\n                background: transparent;\n                display: block;\n                border-color: #FFF;\n                border-style: solid;\n                border-width: 0 5px 0 5px;\n                position: absolute;\n                width: 80px;\n                z-index: 10;\n            }\n\n            .strength-meter:before {\n                left: 70px;\n            }\n\n            .strength-meter:after {\n                right: 70px;\n            }\n\n            .strength-meter-fill {\n                background: transparent;\n                height: inherit;\n                position: absolute;\n                width: 0;\n                border-radius: inherit;\n                transition: width 0.5s ease-in-out, background 0.25s;\n                -webkit-transition: width 0.5s ease-in-out, background 0.25s;\n            }\n\n            .strength-meter-fill[data-strength='0'] {\n                background: darkred;\n                width: 20%;\n            }\n\n            .strength-meter-fill[data-strength='1'] {\n                background: orangered;\n                width: 40%;\n            }\n\n            .strength-meter-fill[data-strength='2'] {\n                background: orange;\n                width: 60%;\n            }\n\n            .strength-meter-fill[data-strength='3'] {\n                background: yellowgreen;\n                width: 80%;\n            }\n\n            .strength-meter-fill[data-strength='4'] {\n                background: green;\n                width: 100%;\n            }\n        "]
                }] }
    ];
    /** @nocollapse */
    StrengthMeterComponent.propDecorators = {
        "measure": [{ type: Output },],
        "value": [{ type: Input },],
    };
    return StrengthMeterComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var /** @type {?} */ COMPONENTS = [StrengthMeterComponent];
var StrengthMeterModule = /** @class */ (function () {
    function StrengthMeterModule() {
    }
    StrengthMeterModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    declarations: COMPONENTS,
                    exports: COMPONENTS
                },] }
    ];
    return StrengthMeterModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// This file only reexports content of the `src` folder. Keep it that way.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { StrengthMeterComponent, StrengthMeterModule };
//# sourceMappingURL=ngx-strength-meter.js.map
